import { withInstall as R, useLoading as Pe, useConfirm as Ae, useForm as Le, usingSFCWithInstall as Re } from "@cphayim-enc/vue";
import { EncKeepAliveRouterView as Oa, EncTransition as Pa, useCountEvent as Aa, useEmitter as La, useEventLock as Ra, useFormData as Ya, useFormItems as Na, useMitten as Ha, usePagination as Ba } from "@cphayim-enc/vue";
import { defineComponent as V, computed as $, openBlock as g, createBlock as I, unref as h, isRef as Y, withCtx as F, createElementBlock as z, Fragment as te, renderList as me, createTextVNode as oe, toDisplayString as K, ref as ne, normalizeClass as ye, createVNode as B, createSlots as Ye, createElementVNode as ue, createCommentVNode as be, renderSlot as $e, normalizeProps as ge, guardReactiveProps as Ve, resolveDynamicComponent as Ne, withModifiers as He, normalizeStyle as fe } from "vue";
import { useVModel as N } from "@vueuse/core";
import { ElCascader as Be, ElCheckboxGroup as ze, ElCheckbox as ve, ElDatePicker as Ge, ElInput as We, ElSelectV2 as je, ElTimePicker as Je, ElUpload as Ze, ElIcon as qe, ElButton as Ke, ElDialog as Qe, ElMessage as q, ElSwitch as Xe, ElRadioGroup as et, ElRadio as tt, ElRate as at, ElFormItem as lt, ElConfigProvider as rt, ElForm as ot, ElRow as nt, ElCol as ut, ElMessageBox as st } from "element-plus";
import "element-plus/es/components/cascader/style/css";
import "element-plus/es/components/checkbox/style/css";
import "element-plus/es/components/checkbox-group/style/css";
import "element-plus/es/components/date-picker/style/css";
import "element-plus/es/components/config-provider/style/css";
import "element-plus/es/components/form/style/css";
import "element-plus/es/components/row/style/css";
import "element-plus/es/components/col/style/css";
import it from "element-plus/es/locale/lang/en";
import dt from "element-plus/es/locale/lang/zh-cn";
import { createThrowErrorFunction as ct, log as he, delayWrapper as mt } from "@cphayim-enc/shared";
import "element-plus/es/components/form-item/style/css";
import "element-plus/es/components/input/style/css";
import "element-plus/es/components/select-v2/style/css";
import "element-plus/es/components/time-picker/style/css";
import { Plus as pt, Upload as ft, Loading as vt } from "@element-plus/icons-vue";
import "element-plus/es/components/upload/style/css";
import "element-plus/es/components/button/style/css";
import "element-plus/es/components/icon/style/css";
import "element-plus/es/components/dialog/style/css";
import { defaultUploadTransformer as ht, UploadTransformerHelper as ce, verifyUploadedFile as _t } from "@cphayim-enc/base";
export * from "@cphayim-enc/base";
import "element-plus/es/components/switch/style/css";
import "element-plus/es/components/radio/style/css";
import "element-plus/es/components/radio-group/style/css";
import "element-plus/es/components/rate/style/css";
import { EncCSSVariables as Wa } from "@cphayim-enc/style";
import "element-plus/es/components/message/style/css";
import "element-plus/es/components/message-box/style/css";
const yt = V({ name: "EncCascaderFormItem" }), bt = /* @__PURE__ */ V({
  ...yt,
  props: {
    modelValue: {},
    item: {}
  },
  setup(m) {
    const n = m, u = {
      placeholder: "请选择",
      cascaderMultiple: !1,
      cascaderFilterable: !1,
      cascaderOptions: [],
      cascaderCheckStrictly: !1,
      cascaderEmitPath: !1
    }, e = $(() => ({ ...u, ...n.item })), a = N(n, "modelValue"), f = $(() => ({
      multiple: e.value.cascaderMultiple,
      expandTrigger: "click",
      checkStrictly: e.value.cascaderCheckStrictly,
      emitPath: e.value.cascaderEmitPath
    }));
    return (v, s) => (g(), I(h(Be), {
      modelValue: h(a),
      "onUpdate:modelValue": s[0] || (s[0] = (p) => Y(a) ? a.value = p : null),
      placeholder: e.value.placeholder,
      options: e.value.cascaderOptions,
      readonly: e.value.readonly,
      disabled: e.value.disabled,
      props: f.value,
      clearable: e.value.clearable,
      filterable: e.value.cascaderFilterable
    }, null, 8, ["modelValue", "placeholder", "options", "readonly", "disabled", "props", "clearable", "filterable"]));
  }
}), xe = R(bt), $t = V({ name: "EncCheckboxFormItem" }), gt = /* @__PURE__ */ V({
  ...$t,
  props: {
    modelValue: {},
    item: {}
  },
  setup(m) {
    const n = m, u = {
      placeholder: "请选择",
      checkboxType: "single",
      checkboxSingleLabel: void 0,
      checkboxGroupOptions: [],
      checkboxGroupMax: 0
    }, e = $(() => ({ ...u, ...n.item })), a = N(n, "modelValue"), f = $(
      () => e.value.checkboxGroupMax === 0 ? void 0 : e.value.checkboxGroupMax
    );
    return (v, s) => e.value.checkboxType === "group" ? (g(), I(h(ze), {
      key: 0,
      modelValue: h(a),
      "onUpdate:modelValue": s[0] || (s[0] = (p) => Y(a) ? a.value = p : null),
      readonly: e.value.readonly,
      disabled: e.value.disabled,
      max: f.value
    }, {
      default: F(() => [
        (g(!0), z(te, null, me(e.value.checkboxGroupOptions, (p, x) => (g(), I(h(ve), {
          key: x,
          label: p.value ?? p.label ?? p,
          disabled: p.disabled
        }, {
          default: F(() => [
            oe(K(p.label ?? p), 1)
          ]),
          _: 2
        }, 1032, ["label", "disabled"]))), 128))
      ]),
      _: 1
    }, 8, ["modelValue", "readonly", "disabled", "max"])) : (g(), I(h(ve), {
      key: 1,
      modelValue: h(a),
      "onUpdate:modelValue": s[1] || (s[1] = (p) => Y(a) ? a.value = p : null),
      "true-label": e.value.checkboxSingleTrueValue,
      "false-label": e.value.checkboxSingleFalseValue,
      readonly: e.value.readonly,
      disabled: e.value.disabled
    }, {
      default: F(() => [
        oe(K(e.value.checkboxSingleLabel), 1)
      ]),
      _: 1
    }, 8, ["modelValue", "true-label", "false-label", "readonly", "disabled"]));
  }
}), Me = R(gt);
var Vt = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function xt(m) {
  return m && m.__esModule && Object.prototype.hasOwnProperty.call(m, "default") ? m.default : m;
}
var we = { exports: {} };
(function(m, n) {
  (function(u, e) {
    m.exports = e();
  })(Vt, function() {
    var u = 1e3, e = 6e4, a = 36e5, f = "millisecond", v = "second", s = "minute", p = "hour", x = "day", O = "week", y = "month", k = "quarter", M = "year", P = "date", C = "Invalid Date", w = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/, G = /\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g, se = { name: "en", weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"), months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_"), ordinal: function(i) {
      var r = ["th", "st", "nd", "rd"], t = i % 100;
      return "[" + i + (r[(t - 20) % 10] || r[t] || r[0]) + "]";
    } }, ie = function(i, r, t) {
      var o = String(i);
      return !o || o.length >= r ? i : "" + Array(r + 1 - o.length).join(t) + i;
    }, Oe = { s: ie, z: function(i) {
      var r = -i.utcOffset(), t = Math.abs(r), o = Math.floor(t / 60), l = t % 60;
      return (r <= 0 ? "+" : "-") + ie(o, 2, "0") + ":" + ie(l, 2, "0");
    }, m: function i(r, t) {
      if (r.date() < t.date())
        return -i(t, r);
      var o = 12 * (t.year() - r.year()) + (t.month() - r.month()), l = r.clone().add(o, y), d = t - l < 0, c = r.clone().add(o + (d ? -1 : 1), y);
      return +(-(o + (t - l) / (d ? l - c : c - l)) || 0);
    }, a: function(i) {
      return i < 0 ? Math.ceil(i) || 0 : Math.floor(i);
    }, p: function(i) {
      return { M: y, y: M, w: O, d: x, D: P, h: p, m: s, s: v, ms: f, Q: k }[i] || String(i || "").toLowerCase().replace(/s$/, "");
    }, u: function(i) {
      return i === void 0;
    } }, Q = "en", W = {};
    W[Q] = se;
    var de = function(i) {
      return i instanceof le;
    }, ae = function i(r, t, o) {
      var l;
      if (!r)
        return Q;
      if (typeof r == "string") {
        var d = r.toLowerCase();
        W[d] && (l = d), t && (W[d] = t, l = d);
        var c = r.split("-");
        if (!l && c.length > 1)
          return i(c[0]);
      } else {
        var b = r.name;
        W[b] = r, l = b;
      }
      return !o && l && (Q = l), l || !o && Q;
    }, T = function(i, r) {
      if (de(i))
        return i.clone();
      var t = typeof r == "object" ? r : {};
      return t.date = i, t.args = arguments, new le(t);
    }, _ = Oe;
    _.l = ae, _.i = de, _.w = function(i, r) {
      return T(i, { locale: r.$L, utc: r.$u, x: r.$x, $offset: r.$offset });
    };
    var le = function() {
      function i(t) {
        this.$L = ae(t.locale, null, !0), this.parse(t);
      }
      var r = i.prototype;
      return r.parse = function(t) {
        this.$d = function(o) {
          var l = o.date, d = o.utc;
          if (l === null)
            return /* @__PURE__ */ new Date(NaN);
          if (_.u(l))
            return /* @__PURE__ */ new Date();
          if (l instanceof Date)
            return new Date(l);
          if (typeof l == "string" && !/Z$/i.test(l)) {
            var c = l.match(w);
            if (c) {
              var b = c[2] - 1 || 0, D = (c[7] || "0").substring(0, 3);
              return d ? new Date(Date.UTC(c[1], b, c[3] || 1, c[4] || 0, c[5] || 0, c[6] || 0, D)) : new Date(c[1], b, c[3] || 1, c[4] || 0, c[5] || 0, c[6] || 0, D);
            }
          }
          return new Date(l);
        }(t), this.$x = t.x || {}, this.init();
      }, r.init = function() {
        var t = this.$d;
        this.$y = t.getFullYear(), this.$M = t.getMonth(), this.$D = t.getDate(), this.$W = t.getDay(), this.$H = t.getHours(), this.$m = t.getMinutes(), this.$s = t.getSeconds(), this.$ms = t.getMilliseconds();
      }, r.$utils = function() {
        return _;
      }, r.isValid = function() {
        return this.$d.toString() !== C;
      }, r.isSame = function(t, o) {
        var l = T(t);
        return this.startOf(o) <= l && l <= this.endOf(o);
      }, r.isAfter = function(t, o) {
        return T(t) < this.startOf(o);
      }, r.isBefore = function(t, o) {
        return this.endOf(o) < T(t);
      }, r.$g = function(t, o, l) {
        return _.u(t) ? this[o] : this.set(l, t);
      }, r.unix = function() {
        return Math.floor(this.valueOf() / 1e3);
      }, r.valueOf = function() {
        return this.$d.getTime();
      }, r.startOf = function(t, o) {
        var l = this, d = !!_.u(o) || o, c = _.p(t), b = function(J, U) {
          var H = _.w(l.$u ? Date.UTC(l.$y, U, J) : new Date(l.$y, U, J), l);
          return d ? H : H.endOf(x);
        }, D = function(J, U) {
          return _.w(l.toDate()[J].apply(l.toDate("s"), (d ? [0, 0, 0, 0] : [23, 59, 59, 999]).slice(U)), l);
        }, E = this.$W, S = this.$M, L = this.$D, Z = "set" + (this.$u ? "UTC" : "");
        switch (c) {
          case M:
            return d ? b(1, 0) : b(31, 11);
          case y:
            return d ? b(1, S) : b(0, S + 1);
          case O:
            var j = this.$locale().weekStart || 0, X = (E < j ? E + 7 : E) - j;
            return b(d ? L - X : L + (6 - X), S);
          case x:
          case P:
            return D(Z + "Hours", 0);
          case p:
            return D(Z + "Minutes", 1);
          case s:
            return D(Z + "Seconds", 2);
          case v:
            return D(Z + "Milliseconds", 3);
          default:
            return this.clone();
        }
      }, r.endOf = function(t) {
        return this.startOf(t, !1);
      }, r.$set = function(t, o) {
        var l, d = _.p(t), c = "set" + (this.$u ? "UTC" : ""), b = (l = {}, l[x] = c + "Date", l[P] = c + "Date", l[y] = c + "Month", l[M] = c + "FullYear", l[p] = c + "Hours", l[s] = c + "Minutes", l[v] = c + "Seconds", l[f] = c + "Milliseconds", l)[d], D = d === x ? this.$D + (o - this.$W) : o;
        if (d === y || d === M) {
          var E = this.clone().set(P, 1);
          E.$d[b](D), E.init(), this.$d = E.set(P, Math.min(this.$D, E.daysInMonth())).$d;
        } else
          b && this.$d[b](D);
        return this.init(), this;
      }, r.set = function(t, o) {
        return this.clone().$set(t, o);
      }, r.get = function(t) {
        return this[_.p(t)]();
      }, r.add = function(t, o) {
        var l, d = this;
        t = Number(t);
        var c = _.p(o), b = function(S) {
          var L = T(d);
          return _.w(L.date(L.date() + Math.round(S * t)), d);
        };
        if (c === y)
          return this.set(y, this.$M + t);
        if (c === M)
          return this.set(M, this.$y + t);
        if (c === x)
          return b(1);
        if (c === O)
          return b(7);
        var D = (l = {}, l[s] = e, l[p] = a, l[v] = u, l)[c] || 1, E = this.$d.getTime() + t * D;
        return _.w(E, this);
      }, r.subtract = function(t, o) {
        return this.add(-1 * t, o);
      }, r.format = function(t) {
        var o = this, l = this.$locale();
        if (!this.isValid())
          return l.invalidDate || C;
        var d = t || "YYYY-MM-DDTHH:mm:ssZ", c = _.z(this), b = this.$H, D = this.$m, E = this.$M, S = l.weekdays, L = l.months, Z = l.meridiem, j = function(U, H, ee, re) {
          return U && (U[H] || U(o, d)) || ee[H].slice(0, re);
        }, X = function(U) {
          return _.s(b % 12 || 12, U, "0");
        }, J = Z || function(U, H, ee) {
          var re = U < 12 ? "AM" : "PM";
          return ee ? re.toLowerCase() : re;
        };
        return d.replace(G, function(U, H) {
          return H || function(ee) {
            switch (ee) {
              case "YY":
                return String(o.$y).slice(-2);
              case "YYYY":
                return _.s(o.$y, 4, "0");
              case "M":
                return E + 1;
              case "MM":
                return _.s(E + 1, 2, "0");
              case "MMM":
                return j(l.monthsShort, E, L, 3);
              case "MMMM":
                return j(L, E);
              case "D":
                return o.$D;
              case "DD":
                return _.s(o.$D, 2, "0");
              case "d":
                return String(o.$W);
              case "dd":
                return j(l.weekdaysMin, o.$W, S, 2);
              case "ddd":
                return j(l.weekdaysShort, o.$W, S, 3);
              case "dddd":
                return S[o.$W];
              case "H":
                return String(b);
              case "HH":
                return _.s(b, 2, "0");
              case "h":
                return X(1);
              case "hh":
                return X(2);
              case "a":
                return J(b, D, !0);
              case "A":
                return J(b, D, !1);
              case "m":
                return String(D);
              case "mm":
                return _.s(D, 2, "0");
              case "s":
                return String(o.$s);
              case "ss":
                return _.s(o.$s, 2, "0");
              case "SSS":
                return _.s(o.$ms, 3, "0");
              case "Z":
                return c;
            }
            return null;
          }(U) || c.replace(":", "");
        });
      }, r.utcOffset = function() {
        return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
      }, r.diff = function(t, o, l) {
        var d, c = this, b = _.p(o), D = T(t), E = (D.utcOffset() - this.utcOffset()) * e, S = this - D, L = function() {
          return _.m(c, D);
        };
        switch (b) {
          case M:
            d = L() / 12;
            break;
          case y:
            d = L();
            break;
          case k:
            d = L() / 3;
            break;
          case O:
            d = (S - E) / 6048e5;
            break;
          case x:
            d = (S - E) / 864e5;
            break;
          case p:
            d = S / a;
            break;
          case s:
            d = S / e;
            break;
          case v:
            d = S / u;
            break;
          default:
            d = S;
        }
        return l ? d : _.a(d);
      }, r.daysInMonth = function() {
        return this.endOf(y).$D;
      }, r.$locale = function() {
        return W[this.$L];
      }, r.locale = function(t, o) {
        if (!t)
          return this.$L;
        var l = this.clone(), d = ae(t, o, !0);
        return d && (l.$L = d), l;
      }, r.clone = function() {
        return _.w(this.$d, this);
      }, r.toDate = function() {
        return new Date(this.valueOf());
      }, r.toJSON = function() {
        return this.isValid() ? this.toISOString() : null;
      }, r.toISOString = function() {
        return this.$d.toISOString();
      }, r.toString = function() {
        return this.$d.toUTCString();
      }, i;
    }(), pe = le.prototype;
    return T.prototype = pe, [["$ms", f], ["$s", v], ["$m", s], ["$H", p], ["$W", x], ["$M", y], ["$y", M], ["$D", P]].forEach(function(i) {
      pe[i[1]] = function(r) {
        return this.$g(r, i[0], i[1]);
      };
    }), T.extend = function(i, r) {
      return i.$i || (i(r, le, T), i.$i = !0), T;
    }, T.locale = ae, T.isDayjs = de, T.unix = function(i) {
      return T(1e3 * i);
    }, T.en = W[Q], T.Ls = W, T.p = {}, T;
  });
})(we);
var Mt = we.exports;
const A = /* @__PURE__ */ xt(Mt), wt = V({ name: "EncDateFormItem" }), Dt = /* @__PURE__ */ V({
  ...wt,
  props: {
    modelValue: {},
    item: {}
  },
  setup(m) {
    const n = m, u = {
      placeholder: "请选择",
      dateType: "date",
      dateFormat: "YYYY-MM-DD",
      dateMinDate: A().subtract(10, "year").toDate(),
      dateMaxDate: A().add(10, "year").toDate()
    }, e = $(() => ({ ...u, ...n.item })), a = $(() => e.value.dateDisplayFormat ?? e.value.dateFormat), f = N(n, "modelValue"), v = $(
      () => e.value.dateMinDate instanceof Date ? e.value.dateMinDate : A(e.value.dateMinDate, e.value.dateFormat).toDate()
    ), s = $(
      () => e.value.dateMaxDate instanceof Date ? e.value.dateMaxDate : A(e.value.dateMaxDate, e.value.dateFormat).toDate()
    ), p = (x) => !!(v.value && A(x).isBefore(A(v.value), "date") || s.value && A(x).isAfter(A(s.value), "date"));
    return (x, O) => (g(), I(h(Ge), {
      type: e.value.dateType,
      modelValue: h(f),
      "onUpdate:modelValue": O[0] || (O[0] = (y) => Y(f) ? f.value = y : null),
      "value-format": e.value.dateFormat,
      format: a.value,
      readonly: e.value.readonly,
      disabled: e.value.disabled,
      clearable: e.value.clearable,
      placeholder: e.value.placeholder,
      "range-separator": e.value.dateRangeSeparator,
      "start-placeholder": e.value.dateRangeStartPlaceholder,
      "end-placeholder": e.value.dateRangeEndPlaceholder,
      "disabled-date": p
    }, null, 8, ["type", "modelValue", "value-format", "format", "readonly", "disabled", "clearable", "placeholder", "range-separator", "start-placeholder", "end-placeholder"]));
  }
}), De = R(Dt), Tt = V({ name: "EncInputFormItem" }), Et = /* @__PURE__ */ V({
  ...Tt,
  props: {
    modelValue: {},
    item: {}
  },
  setup(m) {
    const n = m, u = {
      placeholder: "请输入",
      inputType: "text",
      inputRows: 4
    }, e = $(() => ({ ...u, ...n.item })), a = N(n, "modelValue");
    return (f, v) => (g(), I(h(We), {
      modelValue: h(a),
      "onUpdate:modelValue": v[0] || (v[0] = (s) => Y(a) ? a.value = s : null),
      type: e.value.inputType,
      readonly: e.value.readonly,
      disabled: e.value.disabled,
      placeholder: e.value.placeholder,
      rows: e.value.inputRows,
      maxlength: e.value.inputMaxLength,
      "show-word-limit": "",
      resize: "none"
    }, null, 8, ["modelValue", "type", "readonly", "disabled", "placeholder", "rows", "maxlength"]));
  }
}), Te = R(Et), St = V({ name: "EncSelectFormItem" }), Ft = /* @__PURE__ */ V({
  ...St,
  props: {
    modelValue: {},
    item: {}
  },
  setup(m) {
    const n = m, u = {
      placeholder: "请选择",
      selectMultiple: !1,
      selectFilterable: !1,
      selectOptions: []
    }, e = $(() => ({ ...u, ...n.item })), a = N(n, "modelValue");
    return (f, v) => (g(), I(h(je), {
      modelValue: h(a),
      "onUpdate:modelValue": v[0] || (v[0] = (s) => Y(a) ? a.value = s : null),
      placeholder: e.value.placeholder,
      readonly: e.value.readonly,
      disabled: e.value.disabled,
      multiple: e.value.selectMultiple,
      filterable: e.value.selectFilterable,
      clearable: e.value.clearable,
      options: e.value.selectOptions
    }, null, 8, ["modelValue", "placeholder", "readonly", "disabled", "multiple", "filterable", "clearable", "options"]));
  }
}), Ee = R(Ft), It = V({ name: "EncTimeFormItem" }), kt = /* @__PURE__ */ V({
  ...It,
  props: {
    modelValue: {},
    item: {}
  },
  emits: ["update:modelValue"],
  setup(m, { emit: n }) {
    const u = m, e = {
      "hour-minute": "HH:mm",
      "hour-minute-second": "HH:mm:ss"
    }, a = {
      placeholder: "请选择",
      timeType: "hour-minute"
    }, f = $(() => ({ ...a, ...u.item })), v = $({
      get() {
        if (u.modelValue)
          return A(u.modelValue).isValid() ? A(u.modelValue).toDate() : A(`${A().format("YYYY-MM-DD")} ${u.modelValue}`).toDate();
      },
      set(s) {
        s ? n("update:modelValue", A(s).format(e[f.value.timeType])) : n("update:modelValue", void 0);
      }
    });
    return (s, p) => (g(), I(h(Je), {
      modelValue: v.value,
      "onUpdate:modelValue": p[0] || (p[0] = (x) => v.value = x),
      readonly: f.value.readonly,
      disabled: f.value.disabled,
      placeholder: f.value.placeholder,
      clearable: f.value.clearable,
      format: e[f.value.timeType]
    }, null, 8, ["modelValue", "readonly", "disabled", "placeholder", "clearable", "format"]));
  }
}), Se = R(kt), Ct = { class: "enc-upload__tip" }, Ut = ["src"], Ot = V({ name: "EncUploadFormItem" }), Pt = /* @__PURE__ */ V({
  ...Ot,
  props: {
    modelValue: {},
    item: {}
  },
  emits: ["update:modelValue"],
  setup(m, { emit: n }) {
    const u = m, e = {
      placeholder: "请选择",
      uploadType: "file",
      uploadMultiple: !1,
      uploadMultipleLimit: 3,
      uploadButtonText: "上传文件",
      uploadButtonColor: "#337ecc",
      uploadValidate: () => !0,
      // 这个方法是可选值，但必须由用户传入
      uploadSend: ct("`UploadFormItem.uploadSend` is not implemented"),
      uploadTransformer: ht
    }, a = $(() => ({ ...e, ...u.item })), f = $(
      () => a.value.uploadMultiple ? a.value.uploadMultipleLimit : 1
    ), v = $(
      () => a.value.uploadAccept ?? (a.value.uploadType === "image" ? "image/*" : "*")
    ), s = $(
      () => ce.fromRaw(u.modelValue, a.value)
    ), p = (C) => {
      try {
        const w = a.value.uploadValidate(C);
        if (w === !0)
          return !0;
        throw q.error({ message: w, duration: 3e3 }), new Error(w);
      } catch (w) {
        return he.error(w), !1;
      }
    }, x = async ({ file: C }) => {
      try {
        const w = await a.value.uploadSend(C);
        if (typeof w == "string")
          throw new Error(w);
        _t(w);
        const G = [...s.value, w], se = ce.toRaw(G, a.value);
        n("update:modelValue", se);
      } catch (w) {
        throw he.error(w), q.error({ message: w.message, duration: 3e3 }), w;
      }
    }, O = (C, w) => {
      const G = ce.toRaw(w, a.value);
      n("update:modelValue", G);
    }, y = () => {
      q.warning({ message: "已达到上传数量限制" });
    }, k = ne(), M = ne(!1), P = (C) => {
      k.value = C.url, M.value = !0;
    };
    return (C, w) => (g(), z("div", {
      class: ye(["enc-upload[ep]", {
        limited: s.value.length >= f.value
      }])
    }, [
      B(h(Ze), {
        ref: "uploadRef",
        action: "/",
        accept: v.value,
        "file-list": s.value,
        "before-upload": p,
        "http-request": x,
        limit: f.value,
        "on-remove": O,
        "list-type": a.value.uploadType === "image" ? "picture-card" : "text",
        "on-preview": a.value.uploadType === "image" ? P : void 0,
        "on-exceed": y,
        disabled: a.value.disabled,
        readonly: a.value.readonly
      }, Ye({
        default: F(() => [
          a.value.uploadType === "image" ? (g(), I(h(qe), { key: 0 }, {
            default: F(() => [
              B(h(pt))
            ]),
            _: 1
          })) : (g(), I(h(Ke), {
            key: 1,
            type: "primary",
            color: a.value.uploadButtonColor,
            icon: h(ft)
          }, {
            default: F(() => [
              oe(K(a.value.uploadButtonText || "上传文件"), 1)
            ]),
            _: 1
          }, 8, ["color", "icon"]))
        ]),
        _: 2
      }, [
        a.value.uploadTips ? {
          name: "tip",
          fn: F(() => [
            ue("pre", Ct, K(a.value.uploadTips), 1)
          ]),
          key: "0"
        } : void 0
      ]), 1032, ["accept", "file-list", "limit", "on-remove", "list-type", "on-preview", "disabled", "readonly"]),
      B(h(Qe), {
        modelValue: M.value,
        "onUpdate:modelValue": w[0] || (w[0] = (G) => M.value = G)
      }, {
        default: F(() => [
          ue("img", {
            src: k.value,
            class: "w-full",
            alt: "Preview Image"
          }, null, 8, Ut)
        ]),
        _: 1
      }, 8, ["modelValue"])
    ], 2));
  }
});
const Fe = R(Pt), At = V({ name: "EncSwitchFormItem" }), Lt = /* @__PURE__ */ V({
  ...At,
  props: {
    modelValue: {},
    item: {}
  },
  setup(m) {
    const n = m, u = {
      placeholder: "请输入",
      switchActiveValue: !0,
      switchInactiveValue: !1
    }, e = $(() => ({ ...u, ...n.item })), a = N(n, "modelValue");
    return (f, v) => (g(), I(h(Xe), {
      modelValue: h(a),
      "onUpdate:modelValue": v[0] || (v[0] = (s) => Y(a) ? a.value = s : null),
      "active-value": e.value.switchActiveValue,
      "inactive-value": e.value.switchInactiveValue,
      "active-text": e.value.switchActiveText,
      "inactive-text": e.value.switchInactiveText
    }, null, 8, ["modelValue", "active-value", "inactive-value", "active-text", "inactive-text"]));
  }
}), Ie = R(Lt), Rt = V({ name: "EncRadioFormItem" }), Yt = /* @__PURE__ */ V({
  ...Rt,
  props: {
    modelValue: {},
    item: {}
  },
  setup(m) {
    const n = m, u = {
      placeholder: "请选择",
      radioOptions: []
    }, e = $(() => ({ ...u, ...n.item })), a = N(n, "modelValue");
    return (f, v) => (g(), I(h(et), {
      modelValue: h(a),
      "onUpdate:modelValue": v[0] || (v[0] = (s) => Y(a) ? a.value = s : null),
      readonly: e.value.readonly,
      disabled: e.value.disabled
    }, {
      default: F(() => [
        (g(!0), z(te, null, me(e.value.radioOptions, (s, p) => (g(), I(h(tt), {
          key: p,
          label: s.value ?? s.label ?? s,
          disabled: s.disabled
        }, {
          default: F(() => [
            oe(K(s.label ?? s), 1)
          ]),
          _: 2
        }, 1032, ["label", "disabled"]))), 128))
      ]),
      _: 1
    }, 8, ["modelValue", "readonly", "disabled"]));
  }
}), ke = R(Yt), Nt = {
  key: 0,
  class: "enc-ml-[5px] enc-text-gray-600 enc-text-[14px]"
}, Ht = V({ name: "EncRateFormItem" }), Bt = /* @__PURE__ */ V({
  ...Ht,
  props: {
    modelValue: {},
    item: {}
  },
  setup(m) {
    const n = m, u = {
      placeholder: "请选择",
      rateMax: 5,
      rateAllowHalf: !1,
      rateColor: "#F7BA2A",
      rateVoidColor: "#C6D1DE",
      rateShowText: !1,
      rateTextFormatter: (p) => `${p} 分`
    }, e = $(() => ({ ...u, ...n.item })), a = N(n, "modelValue"), f = $(() => new Array(e.value.rateMax).fill(e.value.rateColor)), v = $(() => {
      var p;
      if (a.value)
        return ((p = e.value.rateTexts) == null ? void 0 : p[a.value - 1]) || e.value.rateTextFormatter(a.value);
    }), s = $(() => e.value.rateMax ? Math.abs(~~e.value.rateMax) : void 0);
    return (p, x) => (g(), z(te, null, [
      B(h(at), {
        modelValue: h(a),
        "onUpdate:modelValue": x[0] || (x[0] = (O) => Y(a) ? a.value = O : null),
        readonly: e.value.readonly,
        disabled: e.value.disabled,
        max: s.value,
        "allow-half": e.value.rateAllowHalf,
        colors: f.value,
        "void-color": e.value.rateVoidColor
      }, null, 8, ["modelValue", "readonly", "disabled", "max", "allow-half", "colors", "void-color"]),
      e.value.rateShowText ? (g(), z("span", Nt, K(v.value), 1)) : be("", !0)
    ], 64));
  }
}), Ce = R(Bt), zt = { class: "enc-form-item[ep]" }, Gt = V({ name: "EncFormItem", inheritAttrs: !1 }), Wt = /* @__PURE__ */ V({
  ...Gt,
  props: {
    modelValue: {},
    item: {}
  },
  emits: ["update:modelValue"],
  setup(m, { emit: n }) {
    const u = m, e = {
      input: Te,
      select: Ee,
      cascader: xe,
      date: De,
      time: Se,
      upload: Fe,
      switch: Ie,
      radio: ke,
      checkbox: Me,
      rate: Ce,
      custom: null
    }, a = $(() => e[u.item.type]), f = N(u, "modelValue", n);
    return (v, s) => (g(), z("div", zt, [
      B(h(lt), {
        label: u.item.label,
        prop: u.item.name,
        rules: u.item.rules
      }, {
        default: F(() => [
          $e(v.$slots, "default", ge(Ve({ item: u.item, value: u.modelValue })), () => [
            (g(), I(Ne(a.value), {
              modelValue: h(f),
              "onUpdate:modelValue": s[0] || (s[0] = (p) => Y(f) ? f.value = p : null),
              item: u.item
            }, null, 8, ["modelValue", "item"]))
          ])
        ]),
        _: 3
      }, 8, ["label", "prop", "rules"])
    ]));
  }
});
const Ue = R(Wt), jt = V({ name: "EncForm", inheritAttrs: !1 }), Jt = /* @__PURE__ */ V({
  ...jt,
  props: {
    data: {},
    items: {},
    size: { default: "default" },
    rowGutter: { default: 8 },
    colGutter: { default: 10 },
    labelWidth: { default: "100px" },
    labelPosition: {},
    locale: { default: "zh-cn" },
    disablePadding: { type: Boolean }
  },
  emits: ["update:data"],
  setup(m, { expose: n, emit: u }) {
    const e = m, a = ne(), f = (y, k) => {
      u("update:data", {
        ...e.data,
        [y]: k
      });
    }, v = async () => {
      if (a.value)
        return new Promise((y, k) => {
          a.value.validate((M, P) => {
            M ? y(void 0) : k(P);
          });
        });
    }, s = async (y) => {
      if (a.value)
        return y || (y = e.items.map((k) => k.name)), mt(() => {
          a.value.clearValidate(typeof y == "string" ? [y] : y);
        }, 0);
    }, p = () => e.data, x = $(() => ({
      marginTop: `${e.rowGutter / 2}px`,
      marginBottom: `${e.rowGutter / 2}px`
    }));
    n({
      validate: v,
      clearValidate: s,
      getValues: p
    });
    const O = $(() => e.locale === "en" ? it : dt);
    return (y, k) => (g(), I(h(rt), { locale: O.value }, {
      default: F(() => [
        ue("div", {
          class: ye(["enc-form[ep]", { "enc-disable-padding": e.disablePadding }])
        }, [
          B(h(ot), {
            ref_key: "formRef",
            ref: a,
            model: e.data,
            "label-width": e.labelWidth,
            "label-position": e.labelPosition,
            size: e.size,
            onSubmit: k[0] || (k[0] = He(() => {
            }, ["prevent"]))
          }, {
            default: F(() => [
              B(h(nt), {
                gutter: e.colGutter * 2
              }, {
                default: F(() => [
                  (g(!0), z(te, null, me(e.items, (M) => (g(), z(te, {
                    key: M.name
                  }, [
                    M.hidden ? be("", !0) : (g(), I(h(ut), {
                      key: 0,
                      span: M.col || 24,
                      style: fe(x.value)
                    }, {
                      default: F(() => {
                        var P;
                        return [
                          ue("div", {
                            style: fe({ width: `${(M.scale ?? 1) * 100}%` })
                          }, [
                            B(h(Ue), {
                              modelValue: (P = e.data) == null ? void 0 : P[M.name],
                              "onUpdate:modelValue": (C) => f(M.name, C),
                              item: M
                            }, {
                              default: F((C) => [
                                $e(y.$slots, M.name, ge(Ve(C)))
                              ]),
                              _: 2
                            }, 1032, ["modelValue", "onUpdate:modelValue", "item"])
                          ], 4)
                        ];
                      }),
                      _: 2
                    }, 1032, ["span", "style"]))
                  ], 64))), 128))
                ]),
                _: 3
              }, 8, ["gutter"])
            ]),
            _: 3
          }, 8, ["model", "label-width", "label-position", "size"])
        ], 2)
      ]),
      _: 3
    }, 8, ["locale"]));
  }
});
const Zt = R(Jt), qt = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  EncCascaderFormItem: xe,
  EncCheckboxFormItem: Me,
  EncDateFormItem: De,
  EncForm: Zt,
  EncFormItem: Ue,
  EncInputFormItem: Te,
  EncRadioFormItem: ke,
  EncRateFormItem: Ce,
  EncSelectFormItem: Ee,
  EncSwitchFormItem: Ie,
  EncTimeFormItem: Se,
  EncUploadFormItem: Fe
}, Symbol.toStringTag, { value: "Module" })), _e = 3e3;
function Sa(m, n) {
  return Pe(m, {
    onLoading: (u) => q({ type: "info", message: u, duration: 0, icon: vt }),
    onClearLoading: (u) => {
      u.close();
    },
    onSuccess: (u) => {
      q({ type: "success", message: u, duration: (n == null ? void 0 : n.duration) ?? _e });
    },
    onError: (u) => {
      q({ type: "error", message: u, duration: (n == null ? void 0 : n.duration) ?? _e });
    },
    ...n
  });
}
function Fa(m) {
  return Ae({
    confirmor: async (n) => {
      try {
        return await st.confirm(n.message, n.title, {
          type: "info",
          confirmButtonText: n.confirmText,
          cancelButtonText: n.cancelText,
          showConfirmButton: !0,
          showCancelButton: !0
        }), !0;
      } catch {
        return !1;
      }
    },
    ...m
  });
}
function Ia(m, n, u) {
  const e = ne(), a = (f) => {
    e.value = f;
  };
  return {
    ...Le(m, n, u),
    formRef: e,
    setFormRef: a
  };
}
const Kt = ({ skipEncInstall: m = !1 } = {}) => ({
  install(n) {
    m || Re(n, qt);
  }
}), ka = Kt();
export {
  Wa as EncCSSVariables,
  xe as EncCascaderFormItem,
  Me as EncCheckboxFormItem,
  De as EncDateFormItem,
  Zt as EncForm,
  Ue as EncFormItem,
  Te as EncInputFormItem,
  Oa as EncKeepAliveRouterView,
  ke as EncRadioFormItem,
  Ce as EncRateFormItem,
  Ee as EncSelectFormItem,
  Ie as EncSwitchFormItem,
  Se as EncTimeFormItem,
  Pa as EncTransition,
  Fe as EncUploadFormItem,
  Kt as createEncElementPlus,
  ka as default,
  Fa as useConfirm,
  Aa as useCountEvent,
  La as useEmitter,
  Ra as useEventLock,
  Ia as useForm,
  Ya as useFormData,
  Na as useFormItems,
  Sa as useLoading,
  Ha as useMitten,
  Ba as usePagination
};
//# sourceMappingURL=index.js.map
